<template>
  <div>
    <div
      v-if="!isNew"
      class="row mb30"
    >
      <div class="col-xs-6">
        <ObDatePickerConstructor
          :value="getValueFromPath(dataSource, 'eventData.occurredAt')"
          label="Дата и время создания"
          :is-time="true"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Инициатор события"
          :value="getValueFromPath(dataSource, 'eventData.authorTitle')"
          :readonly="true"
        />
      </div>
    </div>
    <ObCheckbox
      v-if="isVatPayer"
      :value="getValueFromPath(formData, keys.newVatPrice) > 0"
      label="Тариф указан с учетом НДС"
      data-qa="isVatInclude"
      class="mb15"
      :disabled="true"
    />
    <div class="row mt15">
      <div class="col-xs-6">
        <ObInput
          label="Старый тариф"
          :value="getValueFromPath(formData, keys.oldTariff)"
          type="money:2"
          sub-title="₽"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Сумма НДС"
          :value="getValueFromPath(formData, keys.oldVatPrice)"
          type="money:2"
          sub-title="₽"
          :readonly="true"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-6">
        <ObInput
          label="Новый тариф"
          :value="getValueFromPath(formData, keys.newTariff)"
          type="money:2"
          sub-title="₽"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Сумма НДС"
          :value="getValueFromPath(formData, keys.newVatPrice)"
          type="money:2"
          sub-title="₽"
          :readonly="true"
        />
      </div>
    </div>
    <div
      v-if="isNew || isEditMode || getValueFromPath(formData, keys.comment)"
      class="row"
    >
      <div class="col-xs-12">
        <ObTextarea
          :value="getValueFromPath(formData, keys.comment)"
          label="Комментарий"
          placeholder="Добавьте комментарий"
          :readonly="!isNew && !isNewForm"
          @input="onChangeField(keys.comment, $event)"
        />
      </div>
    </div>
    <template v-if="!currentFiles.length && isEditMode && !isNewForm">
      <div class="title">Нет прикрепленных файлов</div>
    </template>
    <template v-if="currentFiles.length || isNew || isNewForm">
      <div class="title">Прикрепленные файлы</div>
      <ObUploader
        ref="uploader"
        multiple
        :value="currentFiles"
        data-qa="uploader"
        :is-read-only="!isNew && !isNewForm"
        :upload-method="uploadMethod"
        @process-start="startUploadFiles"
        @change="onUploadHandler"
      />
    </template>
  </div>
</template>

<script>
import api from "@/api"
import ObInput from 'common-components/src/obComponents/obInput'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor'
import ObUploader from 'common-components/src/obComponents/obUploader'
import { getValueFromPath } from 'common-components/src/helpers/common'

export default {
  name: 'TariffChangedEventForm',
  components: {
    ObInput,
    ObTextarea,
    ObUploader,
    ObDatePickerConstructor,
    ObCheckbox
  },
  props: {
    formData: {
      type: Object,
      default: () => {}
    },
    isEditMode: {
      type: Boolean,
      default: false
    },
    isNew: {
      type: Boolean,
      default: false
    },
    isNewForm: {
      type: Boolean,
      default: false
    },
    dataSource: {
      type: Object,
      default: () => {}
    },
    order: {
      type: Object,
      default: () => {}
    },
  },
  data () {
    return {}
  },
  watch: {
    currentFiles (value) {
      if (!value || !value.length) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    }
  },
  computed: {
    keys () {
      const isSuborder = Boolean(this.order.isSuborder)

      return {
        oldTariff: isSuborder ? 'specialParameters.oldCarrierTariff.priceWithVat' : 'specialParameters.oldClientTariff.priceWithVat',
        oldVatPrice: isSuborder ? 'specialParameters.oldCarrierTariff.vatPrice' : 'specialParameters.oldClientTariff.vatPrice',
        newTariff: isSuborder ? 'specialParameters.newCarrierTariff.priceWithVat' : 'specialParameters.newClientTariff.priceWithVat',
        newVatPrice: isSuborder ? 'specialParameters.newCarrierTariff.vatPrice' : 'specialParameters.newClientTariff.vatPrice',
        comment: this.isNew ? 'comment' : 'eventData.comment',
        fileUuids: this.isNew ? 'fileUuids' : 'eventData.fileUuids'
      }
    },
    isConfirmable () {
      return true
    },
    uploadMethod () {
      return api.files.postFile
    },
    currentFiles () {
      return this.dataSource?.filesData || []
    },
    isVatPayer () {
      return true
    }
  },
  methods: {
    getValueFromPath (data, path) {
      return getValueFromPath({ data, path })
    },
    startUploadFiles () {
      this.formData.fileUuids = 'loading'
    },
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      if (!data || !data.length) {
        this.onChangeField(this.keys.fileUuids, null)
        return
      }

      this.onChangeField(this.keys.fileUuids, data)
    },
    onChangeField (path, value) {
      this.$emit('change-field', { path, value })
    },
    submitForm () {
      this.$refs.confirmModal.close()
      this.$emit('submit-form')
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.row-input {
  margin-right: 0;
  margin-left: 0;
  flex-wrap: nowrap;
  &__item {
    width: 212px;
    flex-grow: 2;
    &:not(:last-child) {
      margin-right: 10px;
    }
  }
  &__counter {
    width: 135px;
  }
}

.mb10 {
  margin-bottom: 10px!important;
}

.mt10 {
  margin-top: 10px!important;
}

.mb15 {
  margin-bottom: 15px!important;
}

.mt15 {
  margin-top: 15px!important;
}

.mb30 {
  margin-bottom: 30px!important;
}

.mt0 {
  margin-top: 0!important;
}

.radio-block {
  display: flex;
  align-items: center;
  margin-bottom: 15px;
  &::v-deep {
    .ob-radio-container {
      & + .ob-radio-container {
        margin-left: 25px;
      }
    }
  }
}

.tariff-info {
  @include font-mixin(14px, 18px, 400, $color-grey-label);
}

.block-inn {
  margin-bottom: 30px;
  margin-top: 10px;
  span {
    @include font-mixin(14px, 18px, 400, $color-text-base);
    &:first-child {
      margin-right: 7px;
      color: $color-grey-label;
    }
  }
}
</style>